# coding: utf-8

"""
    CLOUD API

    IONOS Enterprise-grade Infrastructure as a Service (IaaS) solutions can be managed through the Cloud API, in addition or as an alternative to the \"Data Center Designer\" (DCD) browser-based tool.    Both methods employ consistent concepts and features, deliver similar power and flexibility, and can be used to perform a multitude of management tasks, including adding servers, volumes, configuring networks, and so on.  # noqa: E501

    The version of the OpenAPI document: 6.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud.configuration import Configuration


class GroupEntities(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {

        'users': 'GroupMembers',

        'resources': 'ResourceGroups',
    }

    attribute_map = {

        'users': 'users',

        'resources': 'resources',
    }

    def __init__(self, users=None, resources=None, local_vars_configuration=None):  # noqa: E501
        """GroupEntities - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._users = None
        self._resources = None
        self.discriminator = None

        if users is not None:
            self.users = users
        if resources is not None:
            self.resources = resources


    @property
    def users(self):
        """Gets the users of this GroupEntities.  # noqa: E501


        :return: The users of this GroupEntities.  # noqa: E501
        :rtype: GroupMembers
        """
        return self._users

    @users.setter
    def users(self, users):
        """Sets the users of this GroupEntities.


        :param users: The users of this GroupEntities.  # noqa: E501
        :type users: GroupMembers
        """

        self._users = users

    @property
    def resources(self):
        """Gets the resources of this GroupEntities.  # noqa: E501


        :return: The resources of this GroupEntities.  # noqa: E501
        :rtype: ResourceGroups
        """
        return self._resources

    @resources.setter
    def resources(self, resources):
        """Sets the resources of this GroupEntities.


        :param resources: The resources of this GroupEntities.  # noqa: E501
        :type resources: ResourceGroups
        """

        self._resources = resources
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GroupEntities):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GroupEntities):
            return True

        return self.to_dict() != other.to_dict()
